=== debian/changelog ===
unicorn-engine (2.1.4-3) unstable; urgency=medium

  * Ignore broken arm/arm64 memhook counter on riscv64 and mips64el

 -- Timo Röhling <roehling@debian.org>  Thu, 16 Oct 2025 14:02:56 +0200

unicorn-engine (2.1.4-2) unstable; urgency=medium

  * Fix test failures on various architectures

 -- Timo Röhling <roehling@debian.org>  Wed, 15 Oct 2025 23:45:14 +0200

unicorn-engine (2.1.4-1) unstable; urgency=medium

  * Migrate debian/watch to version 5 format
  * New upstream version 2.1.4
    - Added loongarch64 support (Closes: #1104201)
  * Update patches.
    - Obsolete: 0004-Skip-broken-armhf-test.patch
    - Obsolete: 0005-Fix-FTBFS-in-ruby-gem.patch
    - Obsolete: 0006-Fix-big-endian-issues.patch
  * Wrap and sort Debian package files
  * Bump Standards-Version to 4.7.2
  * Prevent second library build for Python module
  * Do not install unicorn.o
  * Run pybuild autopkgtest
  * Migrate to PEP 517 build

 -- Timo Röhling <roehling@debian.org>  Thu, 18 Sep 2025 16:40:42 +0200
