=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PYBUILD_NAME = unicorn
export PYBUILD_TEST_ARGS = --ignore=tests/test_network_auditing.py --ignore=tests/test_shellcode.py
export DH_RUBY = --gem-install
export LIBUNICORN_PATH = /anything/to/prevent/duplicate/build

%:
	dh $@ --buildsystem=cmake

ifeq ($(PYBUILD_AUTOPKGTEST),1)
override_dh_auto_test:
	dh_auto_test --buildsystem=pybuild --sourcedirectory=bindings/python 
else
ifneq ($(filter mips64el riscv64,$(DEB_HOST_ARCH)),)
override_dh_auto_test:
	-dh_auto_test --buildsystem=cmake
endif
endif

execute_after_dh_auto_clean-arch \
execute_after_dh_auto_configure-arch \
execute_after_dh_auto_build-arch \
execute_after_dh_auto_install-arch: execute_after_%-arch:
	CPATH=$(CURDIR)/include \
	LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE) \
	$* --buildsystem=ruby

execute_after_dh_auto_configure-indep \
execute_after_dh_auto_build-indep \
execute_after_dh_auto_test-indep \
execute_after_dh_auto_install-indep: execute_after_%-indep:
	LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE) \
	$* --buildsystem=pybuild --sourcedirectory=bindings/python
