=== debian/watch ===
Version: 5

Template: Github
Owner: unicorn-engine
Project: unicorn
Dversion-Mangle: auto
Uversion-Mangle: auto
